# Include file for changing password
use strict;

use Authen::PAM;
use Carp qw/croak/;
use English;

sub my_conv_func {
  my $state = shift(@_);
  my @res;
  while ( @_ ) {
    my $msg_type = shift;
    my $msg = shift;

    my $ans = "";
    if($msg_type == PAM_PROMPT_ECHO_ON() ||
       $msg_type == PAM_PROMPT_ECHO_OFF()) {
      $ans = shift(@$state);
    } elsif($msg_type == PAM_ERROR_MSG()) {
      die "$msg\n";
    }
    push @res, (0,$ans);
  }
  push @res, PAM_SUCCESS();
  return @res;
}

sub changePass {
  my ($service, $userName, $oldPass, $newPass) = @_;
  my $state;

  if($UID == 0) {
    $state = [ $newPass, $newPass ];
  } else {
    $state = [ $oldPass, $newPass, $newPass ];
  }

  my $pamh = new Authen::PAM($service, $userName,
			     sub { my_conv_func($state, @_)} );
  ref($pamh) || die "Error code $pamh during PAM init!";

  my $res = $pamh->pam_chauthtok;
  die $pamh->pam_strerror($res),"\n" unless $res == PAM_SUCCESS();
  undef $pamh;
}

1;
